﻿//=============================================================================
//
// YAC.NET: Yet another Caller ID Program, .NET Edition
// Copyright © 2007 Michael Coyle (michael.coyle@BlueToque.ca)
// http://www.BlueToque.ca/Products/YAC.NET.html
//
//=============================================================================

using System;

namespace YAC_NET
{
    /// <summary>
    /// The IYAC interface defines the basic YAC events
    /// and control mechanisms
    /// </summary>
    interface IYAC
    {
        /// <summary>
        /// The callerID event: triggered when a callerID event is detected.
        /// </summary>
        event CallerIDDelegate CallerID;

        /// <summary>
        /// PhoneRing event triggered when the phone ring event is detected
        /// </summary>
        event PhoneRingDelegate PhoneRing;

        /// <summary>
        /// Message event triggered when a message event is detected
        /// </summary>
        event MessageDelegate Message;

        /// <summary>
        /// Start the YAC interface, listening for events
        /// </summary>
        void Start();

        /// <summary>
        /// Stop the YAC interface, listeneing for events
        /// </summary>
        void Stop();

#if DEBUG
        /// <summary>
        /// Send a debug callerID event: simulates a callerID event on this interface
        /// </summary>
        void SendDebugCallerID();

        /// <summary>
        /// Send a debug Ring event: simulates a ring event on this interface
        /// </summary>
        void SendDebugRing();

        /// <summary>
        /// Send a debug  message event: simulates a message on this interface
        /// </summary>
        void SendDebugMessage();
#endif
    }
}
