using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace YAC_NET.Utility
{
    class FormUtil
    {
        static Dictionary<Type, Form> m_formDictionary = new Dictionary<Type, Form>();

        internal static void Show<T>(IWin32Window mainForm) where T : Form, new()
        {
            if (m_formDictionary.ContainsKey(typeof(T)))
            {
                T form = m_formDictionary[typeof(T)] as T;

                form.BringToFront();

                if (form.WindowState == FormWindowState.Minimized)
                    form.WindowState = FormWindowState.Normal;
            }
            else
            {
                T form = new T();
                form.FormClosed+=new FormClosedEventHandler(form_FormClosed);
                m_formDictionary.Add(typeof(T), form);
                form.ShowDialog(mainForm);
            }
        }

        static void form_FormClosed(object sender, FormClosedEventArgs e)
        {
            Form form =  sender as Form;
            
            if (m_formDictionary.ContainsKey(form.GetType()))
            {
                m_formDictionary.Remove(form.GetType());
            }
        }
    }
}
